import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;

/**
 * Diese Klasse repraesentiert das Hauptfenster der Praedikat-Praesenzaufgabe.
 *
 * @author Annabelle Klarl
 */
public class PraedikatFrame extends JFrame implements ActionListener {
  private JButton duplikatfreiButton;

  private JTextArea ausgabeBereich;

  /** In diesem Programmstueck wird das Fenster erzeugt */
  public PraedikatFrame() {
    /* In der Kopfleiste des Fenster steht "PraedikatFrame" */
    this.setTitle("PraedikatFrame");

    /* Das Fenster ist 500 Pixel breit und 150 Pixel hoch. */
    this.setSize(500, 150);

    /* Hier werden alle Buttons erzeugt. */
    this.duplikatfreiButton = new JButton("Ist Array duplikatfrei?");

    /* Hier wird der Ausgabe-Bereich erzeugt. */
    this.ausgabeBereich = new JTextArea(10, 100);

    /*
     * Der ContentPane ist der Ausschnitt des Fensters, auf dem Widgets d.h.
     * Interaktionselemente (wie eine TextArea oder ein Button) platziert
     * werden koennen.
     */
    Container contentPane = this.getContentPane();
    contentPane.setLayout(new GridLayout(2, 1));
    /* Hier wird der Button platziert. */
    contentPane.add(this.duplikatfreiButton);
    /* Hier wird der Ausgabebereich platziert. */
    contentPane.add(this.ausgabeBereich);

    /*
     * Hier wird der Frame als Listener fuer Knopfdruck-Ereignisse bei jedem
     * der Buttons registriert.
     */
    this.duplikatfreiButton.addActionListener(this);

    /*
     * Wird das Fenster geschlossen (d.h. auf X gedrueckt), wird mit Hilfe
     * dieser Programmzeile auch unser Programm ordnungsgemaess beendet.
     */
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  }

  @Override
  public void actionPerformed(ActionEvent e) {
    // je nach Button entsprechende Methode ausfuehren
    Object source = e.getSource();
    if (source == this.duplikatfreiButton) {
      this.duplikatFrei();
    }
  }

  /** implementiert die Funktionalitaet des "Duplikatfrei"-Buttons */
  private void duplikatFrei() {
    String einlesenArray = JOptionPane.showInputDialog("char-Array: ");
    char[] array = KonverterErweitert.konvertiereZuCharArray(einlesenArray);

    boolean duplikatFrei = istArrayDuplikatfrei(array);

    String eingabe = "Eingabe: " + einlesenArray + "\n\n";
    String ergebnis;
    if (duplikatFrei) {
      ergebnis = eingabe + "Das Array ist duplikatfrei.";
    } else {
      ergebnis = eingabe + "Das Array ist NICHT duplikatfrei.";
    }
    this.ausgabeBereich.setText(ergebnis);
  }

  /**
   * testet, ob das Array duplikatfrei ist
   *
   * @param array
   * @return
   */
  private static boolean istArrayDuplikatfrei(char[] array) {
    for (int i = 0; i < array.length; i++) {
      for (int j = i + 1; j < array.length; j++) {
        if (array[i] == array[j]) {
          return false;
        }
      }
    }
    return true;
  }
}
